#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

// v1.01 - 09/11/2009

/* Globals */
char fengine[50];
char sengine[50];
char data[128] = "help\n";
char cmd[128] = "yes\n";
char side = 'w';
char move[25];
char buf[255];
char sgfname[2048];
char gamenum_buf[15];
char initString[1024];
char lpf_fen[128];
char sgf_buf[2048];
int mg=0;
int args=0;
int turns=0;
int newline=0;
int verbose=0;
int debug=0;
int depth=5;
int i=0;
int sgf_t = 0;
int mgindex = 0;
FILE *sgf;
FILE *lpf;

int in[2], out[2], n, pid;
int in2[2], out2[2], n2, pid2;


int main(int argc, char *argv[]) {
	if(argc <= 4) {
		printf("Please select engines to run\n");
		return 0;
	}
	
	int pos;

	memset(cmd, 0, sizeof(cmd));
	memset(move, 0, sizeof(move));
	memset(fengine, 0, sizeof(fengine));
	memset(sengine, 0, sizeof(sengine));
	memset(sgfname, 0, sizeof(sgfname));
	memset(sgf_buf, 0, sizeof(sgf_buf));

	for(args=1; args<argc; args++) {
		if(strcmp("-fcp", argv[args]) == 0) {
			strcat(fengine, argv[args+1]);			
		}
		if(strcmp("-scp", argv[args]) == 0) {
			strcat(sengine, argv[args+1]);			
		}
		if(strcmp("-v", argv[args]) == 0) {
			verbose = 1;
		}
		if(strcmp("-depth", argv[args]) == 0) {
			depth = atoi(argv[args+1]);
			printf("Depth set: %d\n", depth);
		}
		if(strcmp("-debug", argv[args]) == 0) {
			debug = 1;
		}
		if(strcmp("-sgf", argv[args]) == 0) {
			strcat(sgfname, argv[args+1]);			
			sgf_t = 1; // Set the sgf flag 
			strcat(sgf_buf, "[Event \"cliboard eng vs eng\"]\n");
			strcat(sgf_buf, "[Site \"localhost\"]\n");
			//printf("Done setting sgf header!:\n");
		}
		if(strcmp("-mg", argv[args]) == 0) {
			strcat(gamenum_buf, argv[args+1]);			
			mg = atoi(gamenum_buf);
		}
		// Check for load position file
		if(strcmp("-lpf", argv[args]) == 0) {
			memset(lpf_fen, 0, sizeof(lpf_fen));
			lpf = fopen(argv[args+1], "r");
			fgets(lpf_fen, 128, lpf);
			i = strlen(lpf_fen);
			lpf_fen[i-1] = 0;	
	
			sprintf(initString, "setboard %s\n", lpf_fen);
			printf("%s", initString);
			fclose(lpf);

			// Since this has a custom startup position 
			// inform the PGN of that
			strcat(sgf_buf, "[SetUp \"1\"]\n");
			strcat(sgf_buf, "[FEN \"");
			strcat(sgf_buf, lpf_fen);
			strcat(sgf_buf, "\"]\n");
			printf("%s", sgf_buf);	

		}
	}

	if(debug==1) { printf("Out of args setup:\n"); }

	if(verbose == 1) {
		printf("First engine: %s\n", fengine);
		printf("Second engine: %s\n", sengine);
	}

	if(sgf_t == 1) {
		sgf = fopen(sgfname, "w");
		fprintf(sgf, "%s\n", sgf_buf);
	}

	if(verbose == 1) { 	
		printf("Starting:\n");
	}

	// Start a new game
	newgame();

	while(1) {

		if(side == 'w') {
			n = read(out[0], buf, 255);
			buf[n] = 0;
		}
		if(side == 'b') {
			n = read(out2[0], buf, 255);
			buf[n] = 0;
		}


		if(strstr(buf, "0-1") != NULL) {
			if(verbose==1) { printf("Black wins: %s\n", buf); }
			if(strcmp("", sgfname) != 0) {
				fprintf(sgf, "0-1\n");
			}
			if(mg > 0) { restart(); } else { break; }
		}
		if(strstr(buf, "1-0") != NULL) {
			if(verbose==1) { printf("White wins: %s\n", buf); }
			if(strcmp("", sgfname) != 0) {
				fprintf(sgf, "1-0\n");
			}
			if(mg > 0) { restart(); } else { break; }
		}
		if(strstr(buf, "1/2-1/2") != NULL) {
			if(verbose==1) { printf("Tie: %s\n", buf); }
			if(strcmp("", sgfname) != 0) {
				fprintf(sgf, "1/2-1/2\n");
			}
			if(mg > 0) { restart(); } else { break; }
		}

		lastcmd();

		if(debug==1) { printf("DEBUG %c: %s\n", side, buf); }
		if((strstr(buf, "move") != NULL) && (strstr(buf,"llegal") == NULL)) {
			if(side == 'w') {
				turns += 1;
				//lastcmd();
				strcpy(move, buf + 5, strlen(buf));	
				if(verbose==1) {printf("White> %s", move); }
				write(in2[1], move, strlen(move)); // SE	
				if(strcmp("", sgfname) != 0) {
					newline = strlen(move);
					if(move[newline-1] == '\n') { move[newline-1] = 0; }
					fprintf(sgf, "%d. %s ", turns, move);	
				}
			}
			if(side == 'b') {
				//lastcmd();
				strcpy(move, buf + 5, strlen(buf));	
				if(verbose==1) { printf("Black> %s", move); }
				write(in[1], move, strlen(move)); // SE	
				if(strcmp("", sgfname) != 0) {
					fprintf(sgf, "%s", move);	
				}
			}
			if(side == 'w') { side = 'b'; } else { side = 'w'; }

		}
		memset(buf, 0, sizeof(buf));
		memset(move, 0, sizeof(move));
				
	}

	return 0;
}

int restart() {
	turns = 0;
	side = 'w';
	fprintf(sgf, "\n\n%s\n", sgf_buf);	
	
	closegame();
	newgame();

	if(verbose==1) { printf("Starting new game:\n"); }
}

int closegame() {

	// Clean pipes
	close(in[1]);
	close(out[0]);
	close(in2[1]);
	close(out2[0]);

}

int newgame() {
	mgindex += 1;

	if((mg > 0) && (mgindex > mg)) { exit(0); }

	/* Set pipes for the two engines */
	// Engine 1
	if (pipe(in) < 0) perror("pipe in");
	if (pipe(out) < 0) perror("pipe out");
	// Engine 2
	if (pipe(in2) < 0) perror("pipe in");
	if (pipe(out2) < 0) perror("pipe out");

	// Start first engine
	if ((pid=fork()) == 0) {
		close(0);
		close(1);
		close(2);
		dup2(in[0],0);
		dup2(out[1],1);
		dup2(out[1],2);

		close(in[0]);
		close(in[1]);
		close(out[0]);
		close(out[1]);

		execl(fengine, "", "", (char *)NULL);
		perror("Could not exec first engine");
	}

	// Start second engine
	if ((pid2=fork()) == 0) {
		close(0);
		close(1);
		close(2);
		dup2(in2[0],0);
		dup2(out2[1],1);
		dup2(out2[1],2);

		close(in2[0]);
		close(in2[1]);
		close(out2[0]);
		close(out2[1]);

		execl(sengine, "", "", (char *)NULL);
		perror("Could not exec second engine");
	}
	
	if(verbose==1) {
  		printf("Spawned first engine as a child process at pid %d\n", pid);
	  	printf("Spawned second engine as a child process at pid %d\n", pid2);
	}

	close(in[0]);
	close(out[1]);
	close(in2[0]);
	close(out2[1]);

	// Send initial strings to engines
	memset(data, 0, sizeof(data));	
	strcpy(data, "ponder off\nxboard\n");	
	write(in[1], data, strlen(data)); // FE	
	write(in2[1], data, strlen(data)); // SE	

	// Tell first engine to start	
	memset(data, 0, sizeof(data));	
	sprintf(data, "new\n%ssd=%d\ngo\n", initString, depth);
	//printf("FE: %s\n", data);
	write(in[1], data, strlen(data)); // FE	
	
	// Tell second engine to start	
	memset(data, 0, sizeof(data));	
	sprintf(data, "new\n%ssd=%d\n", initString, depth);
	// printf("SE: %s\n", data);
	write(in2[1], data, strlen(data)); // SE	

}

int lastcmd() {
        int i=0;
        char *token;
        char *movetoken;
	char *buffer[20];
        char *locbuffer[255];
        memset(locbuffer, 0, sizeof(locbuffer));
        memset(buffer, 0, sizeof(buffer));
        strcpy(locbuffer, buf);

        strtok(locbuffer, "\n");  // New line delimited

	// Parse line and look for move. Take into account different engine
	// methods of sending move and convert to "move MOVE";
        while((token = strtok(NULL, "\n")) != NULL) {

		if( (strstr(token, "y move is") != NULL) || (strstr(token, "...") != NULL)) {
			strtok(token, " ");  // space delimited
			while((movetoken = strtok(NULL, " ")) != NULL) {
        			memset(buffer, 0, sizeof(buffer));
				strcat(buffer, "move ");
				strcat(buffer, movetoken);
				strcat(buffer, "\n");
				strcpy(buf, buffer);	
			}

		}
		if(strstr(token, "move") != NULL) {   // if substring containes "move"
                	strcpy(buf, token);
		}
		
        }

}
